#!/usr/bin/python

from struct import *

infile = open('vu1state', 'rb')

for i in range(32):
    raw = infile.read(16)
    regsf = unpack('<ffff', raw)
    regsi = unpack('<IIII', raw)
    print('VF'+str(i).zfill(2), end=' ')
    for j in range(4):
        print('%.6f' % regsf[j], end=' ')
    print()
    print('    ', end=' ')
    for j in range(4):
        print('%08x' % regsi[j], end=' ')
    print()
print()

for i in range(16):
    reg = unpack('<H14x', infile.read(16))[0]
    print('VI'+str(i).zfill(2), '%04x' % reg)
print()

# wtf even are these? The VU1 only has 16 integer registers...
infile.read(16*16)

raw = infile.read(16)
regsf = unpack('<ffff', raw)
regsi = unpack('<IIII', raw)
print('ACC ', end=' ')
for j in range(4):
    print('%.6f' % regsf[j], end=' ')
print()
print('    ', end=' ')
for j in range(4):
    print('%08x' % regsi[j], end=' ')
print()

# the next two are p and q, but i'm not bothering, probably not needed

infile.close()
